import data
# (1.2) Open the fatal encounters file and read it twice.

fin = open("fatal_encounters.csv", "r")
print(fin)
print(fin.read())
print(fin.read())

# (1.3) Close the file, re-open it, and read the first line of the file.
fin.close()
fin = open("fatal_encounters.csv", "r")
header = fin.readline().strip().split(',')

# (1.4) Build up a dataset as a list of lists.
dataset = []
for line in fin.readlines():
	dataset.append(line.strip().split(','))

# (1.5) Use the head function from the data module to view a subset of the data.
data.head(header, dataset, 10)

# (2.1) Implement data_header and data_as_list_of_lists in data.py, then
#       use those functions to load the fatal encounters data again. Use the 
#       head function again to ensure that you're getting the same data as before.
fe_header = data.data_header("fatal_encounters.csv")
fe_dataset = data.data_as_list_of_lists("fatal_encounters.csv")
data.head(fe_header, fe_dataset, 10)

# (2.2) Load the state population data. Use filters to find (i) a state in the FE
# dataset with over 100 shootings, (ii) a demographic group within that state
# that makes up over 10% of the population. Using (i) and (ii), filter the Fatal
# Encounters dataset to only shootings in that state involving that groups.

state_header = data.data_header("state_population.csv")
state_dataset = data.data_as_list_of_lists("state_population.csv")
data.head(state_header, state_dataset, 10)

az_fe = data.filter_categorical(fe_dataset, 6, ["AZ"])
num_az = len(az_fe) # this is over 100
print(num_az)

az_fe_hisp = data.filter_categorical(az_fe, 4, ["hispanic"])
num_az_hisp = len(az_fe_hisp)
print(num_az_hisp)


# (2.3) Get the proportion of all shootings in that state involving members of that group,
# then compare it to their proportion in the state population.
print(round(100*num_az_hisp/num_az, 2), state_dataset[2][5])

# (3)
for idx, state in enumerate(data.get_column(state_dataset, 0)):
	state_subset = data.filter_categorical(fe_dataset, 6, [state])
	state_n = len(state_subset)
	for i, group in enumerate(state_header[1:]):
		state_group_subset = data.filter_categorical(state_subset, 4, [group])
		group_n = len(state_group_subset)
		print(f"{state} {group}\t: {100*group_n/state_n:.0f}% vs. {float(state_dataset[idx][i+1]):.0f}%")
	print()
	
